function area = getCirclesIntersection(r,d)
% calculate the area of intersection between circles 
% imput parameter:  
% r1 : radius circle 1
% r2 : radius circle 2
% d : distance between circle centers
% output:
% area : area of intersection, 0 if no overlap
% Okujeni 2018
r1 = repmat(r,1,size(d,2));
r2 = r1';
a =  (r1.^2-r2.^2+d.^2)./(2*d);
b =  (r2.^2-r1.^2+d.^2)./(2*d);
% case 1
area = real((r1.^2).*acos(a./r1)-a.*sqrt(r1.^2-a.^2)+(r2.^2).*acos(b./r2)-b.*sqrt(r2.^2-b.^2));
% case 2
id = find(d <= abs(r1-r2));
area(id) = pi()*min([r1(id),r2(id)],[],2).^2;    
% case 3
area(find(d >= (r1+r2))) = 0;