function direction = getDirectionTorus(positions,torus_size)
% get the direction between two positions on a torus
% input: 
% positions: Nx2 (x,y positions)
% torus_size: [x_max,y_max]
% Okujeni 2018
n_positions = size(positions,1);
dx = repmat(positions(:,1),1,n_positions)-repmat(positions(:,1),1,n_positions)';
dy = repmat(positions(:,2),1,n_positions)-repmat(positions(:,2),1,n_positions)';
id = abs(dx)>(torus_size(1)-abs(dx));
dx(id) = -dx(id)./abs(dx(id)).*(torus_size(1)-abs(dx(id)));
id = abs(dy)>(torus_size(2)-abs(dy));
dy(id) = -dy(id)./abs(dy(id)).*(torus_size(2)-abs(dy(id)));
direction = dx+dy*i;