function distmat = getDistanceTorus(positions,torus_size)
% get all distances between positions on a torus
% input: 
% positions: Nx2 (x,y positions)
% torus_size: [x_max,y_max]
% Okujeni 2018
n_positions = size(positions,1);
dx = abs(repmat(positions(:,1),1,n_positions)-repmat(positions(:,1),1,n_positions)');
dy = abs(repmat(positions(:,2),1,n_positions)-repmat(positions(:,2),1,n_positions)');
dx = min(dx,torus_size(1)-dx);
dy = min(dy,torus_size(2)-dy);
distmat = sqrt(dx.^2+dy.^2);
distmat(find(eye(n_positions)))=nan;