function [giantcomponent_size,giantcomponent,subnets] = getGiantcomponent(A)
% determines unconnected subnetsworks in a network and returns the giant component
% input: A, boolean adjacency matrix
% Okujeni 2018
subnets = {};
subnets_size = [];
checknodes = 1:size(A,1);
A(find(eye(size(A)))) = 0;
while ~isempty(checknodes)
    currentnodes = checknodes(1);
    checksize = 0;
    while checksize~=length(currentnodes);
        checksize = length(currentnodes);
        currentnodes = find(sum(A(currentnodes,:),1));
        % add starting node in case the node was unconnected
        currentnodes = unique([currentnodes,checknodes(1)]); 
    end
    % remove assigned nodes from the list
    checknodes = setdiff(checknodes,currentnodes);
    % store the found subnet
    subnets = {subnets{:},currentnodes};
    subnets_size = [subnets_size,length(currentnodes)];
end
[giantcomponent_size,id] = max(subnets_size);
giantcomponent = subnets{id};